# rust-networking-examples
<img src="misc/uml.png">


Are you...
- A new PhD student/engineer who is a beginner with the language. 
- Someone unfamiliar with the libraries available for writing distributed rust programs.
- A person who just wants to build a distributed application that supports basic networking with minimal fuss.

This repository might be helpful for you!

# Structure

`/` Rust library containing the Network interface, nothing else.

`/examples/` Examples implementing the Network interface using different methods for transport.


# Prerequisites 

- Some basic understanding of writing async rust code. Although you can still write your application code in a synchronous manner, we opt to use it here to simplify the handling of network events.

- A familiarity with the actor model/pattern of writing async code (see [here](https://ryhl.io/blog/actors-with-tokio/) for a good starting point).